com.fasterxml.jackson.databind.deser.std

## Class EnumDeserializer.FactoryBasedDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<Object>
    - - com.fasterxml.jackson.databind.deser.std.EnumDeserializer.FactoryBasedDeserializer

- All Implemented Interfaces:
    ContextualDeserializer, Serializable
  Enclosing class:
    EnumDeserializer

      protected static class EnumDeserializer.FactoryBasedDeserializer
      extends StdDeserializer<Object>
      implements ContextualDeserializer

  Deserializer that uses a single-String static factory method for locating Enum values by String id.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JsonDeserializer<?>` | `_deser`
    `protected Method` | `_factory`
    `protected Class<?>` | `_inputType`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `EnumDeserializer.FactoryBasedDeserializer(Class<?> cls, AnnotatedMethod f, Class<?> inputType)`
    `protected` | `EnumDeserializer.FactoryBasedDeserializer(EnumDeserializer.FactoryBasedDeserializer base, JsonDeserializer<?> deser)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `JsonDeserializer<?>` | `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
    `Object` | `deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `Object` | `deserializeWithType(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_deserializeFromEmpty, _hasTextualNull, _isNaN, _isNegInf, _isPosInf, _parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, getValueClass, getValueType, handledType, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserialize, findBackReference, getDelegatee, getEmptyValue, getKnownPropertyNames, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _inputType

          protected final Class<?> _inputType

    - #### _factory

          protected final Method _factory

    - #### _deser

          protected final JsonDeserializer<?> _deser

  - ### Constructor Detail

    - #### EnumDeserializer.FactoryBasedDeserializer

          public EnumDeserializer.FactoryBasedDeserializer(Class<?> cls,
                                                   AnnotatedMethod f,
                                                   Class<?> inputType)

    - #### EnumDeserializer.FactoryBasedDeserializer

          protected EnumDeserializer.FactoryBasedDeserializer(EnumDeserializer.FactoryBasedDeserializer base,
                                                   JsonDeserializer<?> deser)

  - ### Method Detail

    - #### createContextual

          public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                             BeanProperty property)
                                               throws JsonMappingException

      Description copied from interface: `ContextualDeserializer`
      Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.
      Specified by:
        `createContextual` in interface `ContextualDeserializer`
      Parameters:
        `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
        `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
      Returns:
        Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### deserialize

          public Object deserialize(com.fasterxml.jackson.core.JsonParser jp,
                           DeserializationContext ctxt)
                             throws IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (jp.getCurrentToken() == JsonToken.START_OBJECT) {
                   jp.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<Object>`
      Parameters:
        `jp` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `IOException`

    - #### deserializeWithType

          public Object deserializeWithType(com.fasterxml.jackson.core.JsonParser jp,
                                   DeserializationContext ctxt,
                                   TypeDeserializer typeDeserializer)
                                     throws IOException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<Object>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`

Copyright © 2014-2015 FasterXML. All Rights Reserved.